import { BefrestConnectionMode } from "./befrest-connection-mode";
import { BefrestMessage } from "./befrest-message";
export interface BefrestMessageHandler {
    /**
     * call when befrest connection has changed
     * @param connectionMode has 3 state : CONNECTED , DISCONNECTED , RETRY
     * to show befrest state connection
     */
    onConnectionChanged(connectionMode: BefrestConnectionMode): void;
    /**
     * call when authorize problem happen in befrest
     */
    onAuthorizeProblem(): void;
    /**
     * call when befrest connect to the server
     */
    onBefrestConnect(): void;
    /**
     *call when befrest connection refresh
     */
    onConnectionRefreshed(): void;
    /**
     * call when new Messages received from befrest
     * @param befrestMessages array of messages that received from servoer
     */
    onMessagesReceived(befrestMessages: BefrestMessage[]): void;
}
