"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var MsgType;
(function (MsgType) {
    MsgType[MsgType["NORMAL"] = 0] = "NORMAL";
    MsgType[MsgType["BATCH"] = 1] = "BATCH";
    MsgType[MsgType["TOPIC"] = 2] = "TOPIC";
    MsgType[MsgType["GROUP"] = 3] = "GROUP";
})(MsgType = exports.MsgType || (exports.MsgType = {}));
var BefrestMessage = /** @class */ (function () {
    function BefrestMessage(data) {
        this.isCorrupted = false;
        this.messagePattern = JSON.parse(data);
        if (!this.messagePattern.t || !this.messagePattern.ts || !this.messagePattern.m) {
            this.isCorrupted = true;
        }
        else {
            this.data = utils_1.b64DecodeUnicode(this.messagePattern.m);
            this.timeStamp = this.messagePattern.ts;
            this.messageId = this.messagePattern.mid;
            this.setMessageType();
        }
    }
    BefrestMessage.prototype.setMessageType = function () {
        switch (this.messagePattern.t) {
            case 1:
                this.messageType = MsgType.NORMAL;
                break;
            case 2:
                this.messageType = MsgType.BATCH;
                break;
            case 3:
                this.messageType = MsgType.TOPIC;
                break;
            case 4:
                this.messageType = MsgType.GROUP;
                break;
            default:
                this.isCorrupted = true;
                break;
        }
    };
    Object.defineProperty(BefrestMessage.prototype, "message", {
        get: function () {
            return this.data;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BefrestMessage.prototype, "corruptionFlag", {
        get: function () {
            return this.isCorrupted;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BefrestMessage.prototype, "getType", {
        get: function () {
            return this.messageType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BefrestMessage.prototype, "getAckMessage", {
        get: function () {
            if (this.getMessageType)
                return "A" + this.getMessageType.toString().toUpperCase().charAt(0) + this.messageId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BefrestMessage.prototype, "getMessageType", {
        get: function () {
            switch (this.messagePattern.t) {
                case 1:
                    return ("NORMAL");
                case 2:
                    return ("BATCH");
                case 3:
                    return ("TOPIC");
                case 4:
                    return ("GROUP");
                default:
                    this.isCorrupted = true;
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    return BefrestMessage;
}());
exports.BefrestMessage = BefrestMessage;
