import { BefrestMessageHandler } from "./befrest-message-handler";
export declare class Befrest {
    private static instance;
    private befrestInternal;
    constructor();
    static getInstance(): Befrest;
    /**
     *init befrest with aid , chid  ,authToken and messageHandler
     * call this method first to use befrest
     */
    init(aid: string, chid: string, authToken: string, messageHandler: BefrestMessageHandler): void;
    /**
     *The befrest start method create connection to server to receive and send messages through websocket
     *call this method after init to start befrest
     */
    start(): void;
    /**
     * The befrest stop method disconnect from server after calling this method no message receive from befrest
     * call this method whenever you want to stop befrest
     */
    stop(): void;
    /**
     * The commitTopic method will be stop befrest and start again to update topic list in server
     * call this method whenever you add or remove topic(recommended)
     */
    commitTopic(): void;
    /**
     * The refresh method send ping payload to server whenever you call to check connection status
     * and notifying you in onConnectionRefresh callback.
     */
    refresh(): void;
    /**
     * The getTopicList method return a string array that show current topics that your client subscribed
     */
    getTopicList(): string[];
    /**
     * The addTopic method use to add specific topic
     * @param topic is a topic that you want to add
     * @return true if new topic added successfully and false if your topic has already exist
     */
    addTopic(topic: string): boolean | null;
    /**
     * The removeTopic method use to remove specific topic
     * @param topic is a topic that you want to remove
     * @return true if topic remove successfully and false if topic not exists in topic list
     */
    removeTopic(topic: string): boolean;
}
