
import {BefrestMessageHandler} from "./befrest-message-handler";
import {BefrestConnectionMode} from "./befrest-connection-mode";
import {BefrestMessage} from "./befrest-message";

export class ClientData {
    private static instance: ClientData;
    private _aid: string;
    private _chid: string;
    private _authToken?: string;
    private _topics: string;
    private _messageHandler: BefrestMessageHandler;

    private constructor() {
        this._aid = "";
        this._topics = "";
        this._chid = "";
        this._topics = "";
        this._messageHandler = new class implements BefrestMessageHandler {
            onAuthorizeProblem(): void {
            }

            onBefrestConnect(): void {
            }

            onConnectionChanged(connectionMode: BefrestConnectionMode): void {
            }

            onConnectionRefreshed(): void {
            }

            onMessagesReceived(befrestMessages: BefrestMessage[]): void {
            }
        }

    }

    public static getInstance() {
        if (!ClientData.instance) {
            ClientData.instance = new ClientData();
        }
        return ClientData.instance;
    }

    set aid(value: string) {
        this._aid = value;
    }

    set chid(value: string) {
        this._chid = value;
    }

    set authToken(value: string) {
        this._authToken = value;
    }

    set topics(value: string) {
        this._topics = value;
    }

    get messageHandler(): BefrestMessageHandler {
        return this._messageHandler;
    }


    set messageHandler(value: BefrestMessageHandler) {
        this._messageHandler = value;
    }

    get aid(): string {
        return this._aid;
    }

    get chid(): string {
        return this._chid;
    }

    get authToken(): string {
        if (this._authToken)
        return this._authToken;
        return "";
    }

    get topics(): string {
        return this._topics;
    }
}